#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdlib.h>
#include <malloc.h>
#pragma warning(push,1)
#include "plugin.hpp"
#pragma warning(pop)
#include "htmlhelp.h"

FARAPIEDITORCONTROL EditorControl;

static int IsWrdSym( char Symbol )
{
    Symbol&=0xDF; // toupper
    return ( Symbol>='A' && Symbol<='Z' ||
              Symbol>='0' && Symbol<='9' ||
              Symbol=='_' );
}

void WINAPI SetStartupInfo(const struct PluginStartupInfo *Info)
{
    EditorControl=Info->EditorControl;
}

HANDLE WINAPI OpenPlugin(int OpenFrom,int Item)
{
    char szPath[_MAX_PATH];
    HKEY hKeyCol, hKeyLang, hKeyLoc;
    DWORD dwSize, dwType;

    (void)Item;
    (void)OpenFrom;

    if( RegOpenKeyEx(HKEY_LOCAL_MACHINE,"SOFTWARE\\Microsoft\\HTML Help Collections\\Developer Collections",0,KEY_READ,&hKeyCol)==ERROR_SUCCESS ){
        dwSize=sizeof(szPath);
        if( RegQueryValueEx(hKeyCol,"Language",0,&dwType,(LPBYTE)szPath,&dwSize)==ERROR_SUCCESS ){
            dwSize=sizeof(szPath);
            if( RegOpenKeyEx(hKeyCol,szPath,0,KEY_READ,&hKeyLang)==ERROR_SUCCESS ){
                dwSize=sizeof(szPath);
                if( RegQueryValueEx(hKeyLang,"Preferred",0,&dwType,(LPBYTE)szPath,&dwSize)==ERROR_SUCCESS ){
                    if( RegOpenKeyEx(hKeyLang,szPath,0,KEY_READ,&hKeyLoc)==ERROR_SUCCESS ){
                        dwSize=sizeof(szPath);
                        if( RegQueryValueEx(hKeyLoc,"Filename",0,&dwType,(LPBYTE)szPath,&dwSize)==ERROR_SUCCESS ){
                            HH_AKLINK link;
                            struct EditorInfo ei;
                            struct EditorGetString str;
                            struct EditorConvertText ect;

                            memset(&link,0,sizeof(link));
                            link.cbStruct = sizeof(HH_AKLINK);
                            link.pszKeywords = "";
                            link.fIndexOnFail = TRUE;

                            EditorControl(ECTL_GETINFO,&ei);
                            str.StringNumber = -1;
                            EditorControl( ECTL_GETSTRING, &str );

                            if( str.StringLength <= ei.CurPos ) ei.CurPos=str.StringLength-1;
                            if( ei.CurPos>=0 ){
                                char *Text;

                                Text=ect.Text=alloca(str.StringLength+1);
                                if( ect.Text ){
                                    int beg, end;

                                    memcpy(Text,str.StringText,str.StringLength);
                                    ect.TextLength=str.StringLength;
                                    EditorControl(ECTL_EDITORTOOEM,&ect);

                                    beg=ei.CurPos;

                                    if( beg>=ect.TextLength ) beg=ect.TextLength-1;
                                    while( beg>0 && !IsWrdSym(Text[beg]) ) beg--;
                                    while( beg>0 && IsWrdSym(Text[beg]) ) beg--;
                                    while( beg<ect.TextLength && !IsWrdSym(Text[beg]) ) beg++;
                                    end=beg;
                                    while( end<ect.TextLength && IsWrdSym(Text[end]) ) end++;
                                    Text[(end>beg)?end:beg] = '\0';
                                    link.pszKeywords=&Text[beg];
                                }
                            }

                            HtmlHelp(0,szPath,HH_KEYWORD_LOOKUP,(DWORD)&link);
                        }
                        RegCloseKey(hKeyLoc);
                    }
                }
                RegCloseKey(hKeyLang);
            }
        }
        RegCloseKey(hKeyCol);
    }

    return(INVALID_HANDLE_VALUE);
}

void WINAPI GetPluginInfo(struct PluginInfo *Info)
{
    static char *PluginMenuStrings[1];

    Info->StructSize=sizeof(*Info);
    Info->Flags=PF_EDITOR|PF_DISABLEPANELS;
    PluginMenuStrings[0]="MSDN";

    Info->PluginMenuStrings=PluginMenuStrings;
    Info->PluginMenuStringsNumber=sizeof(PluginMenuStrings)/sizeof(PluginMenuStrings[0]);
}
